summaryrefslogtreecommitdiffstats
path: root/multimedia/ffmpeg4/ffmpeg4.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'multimedia/ffmpeg4/ffmpeg4.SlackBuild')
-rw-r--r--multimedia/ffmpeg4/ffmpeg4.SlackBuild232
1 files changed, 232 insertions, 0 deletions
diff --git a/multimedia/ffmpeg4/ffmpeg4.SlackBuild b/multimedia/ffmpeg4/ffmpeg4.SlackBuild
new file mode 100644
index 0000000000..a14ef3f8c7
--- /dev/null
+++ b/multimedia/ffmpeg4/ffmpeg4.SlackBuild
@@ -0,0 +1,232 @@
+#!/bin/sh
+
+# Slackware build script for ffmpeg4
+
+# Copyright 2018 Andreas Guldstrand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=ffmpeg4
+SRCNAM=ffmpeg
+VERSION=${VERSION:-4.0.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+enable() {
+ VAR="$1"; shift
+ DEF="$1"; shift
+ YES="$1"; shift
+ NO="$1"; shift
+ eval "$VAR=\${$VAR:-$DEF}"
+ eval "enable_$VAR=\"$NO\""
+ eval "[ \"\$$VAR\" = \"yes\" ] && enable_$VAR=\"$YES\""
+}
+
+# set "enable_$VAR" variables
+ # ENV VAR DEFAULT IF YES IF NO
+enable "BINS" "no" "" "--disable-programs --disable-manpages"
+enable "CHROMAPRINT" "no" "--enable-chromaprint" ""
+enable "DECKLINK" "no" "--enable-decklink" ""
+enable "FREI0R" "no" "--enable-frei0r" ""
+enable "GNUTLS" "no" "--enable-gnutls" ""
+enable "LADSPA" "no" "--enable-ladspa" ""
+enable "LIBBLURAY" "no" "--enable-libbluray" ""
+enable "LIBBS2B" "no" "--enable-libbs2b" ""
+enable "LIBCACA" "yes" "--enable-libcaca" ""
+enable "LIBCDIO" "yes" "--enable-libcdio" ""
+enable "LIBCELT" "no" "--enable-libcelt" ""
+enable "LIBDC1394" "no" "--enable-libdc1394" ""
+enable "LIBFDK_AAC" "no" "--enable-nonfree --enable-libfdk_aac" ""
+enable "LIBFLITE" "no" "--enable-libflite" ""
+enable "LIBFONTCONFIG" "yes" "--enable-libfontconfig" ""
+enable "LIBFREETYPE" "yes" "--enable-libfreetype" ""
+enable "LIBFRIBIDI" "yes" "--enable-libfribidi" ""
+enable "LIBGME" "no" "--enable-libgme" ""
+enable "LIBGSM" "no" "--enable-libgsm" ""
+enable "LIBIEC61883" "no" "--enable-libiec61883" ""
+enable "LIBILBC" "no" "--enable-libilbc" ""
+enable "LIBMODPLUG" "no" "--enable-libmodplug" ""
+enable "LIBMP3LAME" "no" "--enable-libmp3lame" ""
+enable "LIBOPENCORE" "no" "--enable-libopencore-amrnb --enable-libopencore-amrwb" ""
+enable "LIBOPENCV" "no" "--enable-libopencv" ""
+enable "LIBOPENJPEG" "yes" "--enable-libopenjpeg" ""
+enable "LIBOPUS" "no" "--enable-libopus" ""
+enable "LIBPULSE" "yes" "--enable-libpulse" ""
+enable "LIBRTMP" "no" "--enable-librtmp" ""
+enable "LIBRUBBERBAND" "no" "--enable-librubberband" ""
+enable "LIBSMBCLIENT" "yes" "--enable-libsmbclient" ""
+enable "LIBSNAPPY" "no" "--enable-libsnappy" ""
+enable "LIBSPEEX" "no" "--enable-libspeex" ""
+enable "LIBSSH" "yes" "--enable-libssh" ""
+enable "LIBTESSERACT" "no" "--enable-libtesseract" ""
+enable "LIBTHEORA" "yes" "--enable-libtheora" ""
+enable "LIBTWOLAME" "no" "--enable-libtwolame" ""
+enable "LIBV4L2" "yes" "--enable-libv4l2" ""
+enable "LIBVIDSTAB" "no" "--enable-libvidstab" ""
+enable "LIBVORBIS" "yes" "--enable-libvorbis" ""
+enable "LIBVPX" "yes" "--enable-libvpx" ""
+enable "LIBWAVPACK" "yes" "--enable-libwavpack" ""
+enable "LIBWEBP" "no" "--enable-libwebp" ""
+enable "LIBX264" "no" "--enable-libx264" ""
+enable "LIBX265" "no" "--enable-libx265" ""
+enable "LIBXVID" "no" "--enable-libxvid" ""
+enable "LIBZMQ" "no" "--enable-libzmq" ""
+enable "LIBZVBI" "no" "--enable-libzvbi" ""
+enable "OPENAL" "no" "--enable-openal" ""
+enable "OPENGL" "yes" "--enable-opengl" ""
+enable "OPENSSL" "yes" "--enable-nonfree --enable-openssl" ""
+
+[ "$DECKLINK" = "yes" ] && SLKCFLAGS="$SLKCFLAGS -I/usr/include/decklink"
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.bz2
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX}/ffmpeg4 \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION/html \
+ --incdir=/usr/include/ffmpeg4 \
+ --enable-rpath \
+ --disable-podpages \
+ --disable-txtpages \
+ --arch=$ARCH \
+ --enable-gpl \
+ --enable-version3 \
+ --enable-shared \
+ --disable-static \
+ --disable-debug \
+ --enable-libass \
+ $enable_BINS \
+ $enable_CHROMAPRINT \
+ $enable_DECKLINK \
+ $enable_FREI0R \
+ $enable_GNUTLS \
+ $enable_LADSPA \
+ $enable_LIBBLURAY \
+ $enable_LIBBS2B \
+ $enable_LIBCACA \
+ $enable_LIBCDIO \
+ $enable_LIBCELT \
+ $enable_LIBDC1394 \
+ $enable_LIBFDK_AAC \
+ $enable_LIBFLITE \
+ $enable_LIBFONTCONFIG \
+ $enable_LIBFREETYPE \
+ $enable_LIBFRIBIDI \
+ $enable_LIBGME \
+ $enable_LIBGSM \
+ $enable_LIBIEC61883 \
+ $enable_LIBILBC \
+ $enable_LIBMODPLUG \
+ $enable_LIBMP3LAME \
+ $enable_LIBOPENCORE \
+ $enable_LIBOPENCV \
+ $enable_LIBOPENJPEG \
+ $enable_LIBOPUS \
+ $enable_LIBPULSE \
+ $enable_LIBRTMP \
+ $enable_LIBRUBBERBAND \
+ $enable_LIBSMBCLIENT \
+ $enable_LIBSNAPPY \
+ $enable_LIBSPEEX \
+ $enable_LIBSSH \
+ $enable_LIBTESSERACT \
+ $enable_LIBTHEORA \
+ $enable_LIBTWOLAME \
+ $enable_LIBV4L2 \
+ $enable_LIBVIDSTAB \
+ $enable_LIBVORBIS \
+ $enable_LIBVPX \
+ $enable_LIBWAVPACK \
+ $enable_LIBWEBP \
+ $enable_LIBX264 \
+ $enable_LIBX265 \
+ $enable_LIBXVID \
+ $enable_LIBZMQ \
+ $enable_LIBZVBI \
+ $enable_OPENAL \
+ $enable_OPENGL \
+ $enable_OPENSSL
+
+make
+make install DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+if [ "$BINS" = "yes" ]; then
+ find $PKG/usr/man -type f -exec gzip -9 {} \;
+ for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ Changelog CONTRIBUTING.md COPYING.GPLv2 COPYING.GPLv3 COPYING.LGPLv2.1 COPYING.LGPLv3 \
+ CREDITS INSTALL.md LICENSE.md MAINTAINERS README.md RELEASE RELEASE_NOTES VERSION \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+mv $PKG/usr/share $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}